unit UTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,UParseText,
  StdCtrls;

type
  TTestForm = class(TForm)
    Edit1: TEdit;
    ff: TButton;
    Memo1: TMemo;
    fn: TButton;
    sp: TButton;
    fp: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ParseText1: TParseText;
    fl: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ffClick(Sender: TObject);
    procedure fnClick(Sender: TObject);
    procedure spClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure fpClick(Sender: TObject);
    procedure ParseText1AfterFindFirst(matchCount: Integer);
    procedure ParseText1AfterFindNext(actMatch: Integer);
    procedure ParseText1AfterFindPrev(actMatch: Integer);
    procedure flClick(Sender: TObject);
    procedure ParseText1AfterFindLast(actMatch: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    loc : TLocation;
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}

procedure TTestForm.FormCreate(Sender: TObject);
begin
  ParseText1.text := memo1.Text;
  ParseText1.pattern := edit1.text;
  memo1.SelStart := 0;
  memo1.SelLength := 0;
end;

procedure TTestForm.ffClick(Sender: TObject);
begin
  ParseText1.findFirst(loc);
  fp.Enabled := True;
  fn.Enabled := True;
  fl.Enabled := True;
  sp.Enabled := True;
  memo1.SetFocus;
  memo1.SelStart := loc.start-1;
  memo1.SelLength := loc.len;
end;

procedure TTestForm.fpClick(Sender: TObject);
begin
  ParseText1.findPrev(loc);
  memo1.SetFocus;
  memo1.SelStart := loc.start-1;
  memo1.SelLength := loc.len;
end;

procedure TTestForm.fnClick(Sender: TObject);
begin
  ParseText1.findNext(loc);
  memo1.SetFocus;
  memo1.SelStart := loc.start-1;
  memo1.SelLength := loc.len;
end;

procedure TTestForm.spClick(Sender: TObject);
begin
  ParseText1.showPattern;
end;

procedure TTestForm.Edit1Change(Sender: TObject);
begin
  ParseText1.pattern := edit1.text; 
  Label5.Caption := '';
  Label6.Caption := ''; 
  fp.Enabled := False;
  fn.Enabled := False;
  fl.Enabled := False;
  sp.Enabled := False;
end;
                                                      
procedure TTestForm.Memo1Change(Sender: TObject);   
begin
  ParseText1.text := memo1.Text;
  Label5.Caption := '';
  Label6.Caption := '';
  fp.Enabled := False;
  fn.Enabled := False;
  fl.Enabled := False; 
  sp.Enabled := False;
end;

procedure TTestForm.ParseText1AfterFindFirst(matchCount: Integer);
begin
  Label5.Caption := intToStr(matchCount);
  if matchCount <> 0 then
    Label6.Caption := '1'
  else
    Label6.Caption := '';
end;

procedure TTestForm.ParseText1AfterFindNext(actMatch: Integer);
begin
  Label6.Caption := intToStr(actMatch);  
end;

procedure TTestForm.ParseText1AfterFindPrev(actMatch: Integer);
begin
  Label6.Caption := intToStr(actMatch);
end;


procedure TTestForm.flClick(Sender: TObject);
begin
  ParseText1.findLast(loc);
  memo1.SetFocus;
  memo1.SelStart := loc.start-1;
  memo1.SelLength := loc.len;
end;

procedure TTestForm.ParseText1AfterFindLast(actMatch: Integer);
begin
  Label6.Caption := intToStr(actMatch);
end;

end.
